/*----------------------------------------------------------------------------
 *      Exynos SoC  -  GPIO
 *----------------------------------------------------------------------------
 *      Name:    gpio9610.c
 *      Purpose: To implement GPIO driver functions
 *      Rev.:    V1.00
 *----------------------------------------------------------------------------
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __GPIO9610_C__
#define __GPIO9610_C__


#define    REG_GPIO_GPH0CON     (GPIO_BASE_ADDRESS + 0x00)
#define    REG_GPIO_GPH1CON     (GPIO_BASE_ADDRESS + 0x20)

#define    REG_GPIO_GPM00CON    (GPIO_CMGP_BASE_ADDRESS + 0x00)
#define    REG_GPIO_GPM01CON    (GPIO_CMGP_BASE_ADDRESS + 0x20)
#define    REG_GPIO_GPM02CON    (GPIO_CMGP_BASE_ADDRESS + 0x40)
#define    REG_GPIO_GPM03CON    (GPIO_CMGP_BASE_ADDRESS + 0x60)
#define    REG_GPIO_GPM04CON    (GPIO_CMGP_BASE_ADDRESS + 0x80)
#define    REG_GPIO_GPM05CON    (GPIO_CMGP_BASE_ADDRESS + 0xA0)
#define    REG_GPIO_GPM06CON    (GPIO_CMGP_BASE_ADDRESS + 0xC0)
#define    REG_GPIO_GPM07CON    (GPIO_CMGP_BASE_ADDRESS + 0xE0)
#define    REG_GPIO_GPM08CON    (GPIO_CMGP_BASE_ADDRESS + 0x100)
#define    REG_GPIO_GPM09CON    (GPIO_CMGP_BASE_ADDRESS + 0x120)
#define    REG_GPIO_GPM10CON    (GPIO_CMGP_BASE_ADDRESS + 0x140)
#define    REG_GPIO_GPM11CON    (GPIO_CMGP_BASE_ADDRESS + 0x160)
#define    REG_GPIO_GPM12CON    (GPIO_CMGP_BASE_ADDRESS + 0x180)
#define    REG_GPIO_GPM13CON    (GPIO_CMGP_BASE_ADDRESS + 0x1A0)
#define    REG_GPIO_GPM14CON    (GPIO_CMGP_BASE_ADDRESS + 0x1C0)
#define    REG_GPIO_GPM15CON    (GPIO_CMGP_BASE_ADDRESS + 0x1E0)
#define    REG_GPIO_GPM16CON    (GPIO_CMGP_BASE_ADDRESS + 0x200)
#define    REG_GPIO_GPM17CON    (GPIO_CMGP_BASE_ADDRESS + 0x220)
#define    REG_GPIO_GPM18CON    (GPIO_CMGP_BASE_ADDRESS + 0x240)
#define    REG_GPIO_GPM19CON    (GPIO_CMGP_BASE_ADDRESS + 0x260)
#define    REG_GPIO_GPM20CON    (GPIO_CMGP_BASE_ADDRESS + 0x280)
#define    REG_GPIO_GPM21CON    (GPIO_CMGP_BASE_ADDRESS + 0x2A0)
#define    REG_GPIO_GPM22CON    (GPIO_CMGP_BASE_ADDRESS + 0x2C0)
#define    REG_GPIO_GPM23CON    (GPIO_CMGP_BASE_ADDRESS + 0x2E0)
#define    REG_GPIO_GPM24CON    (GPIO_CMGP_BASE_ADDRESS + 0x300)
#define    REG_GPIO_GPM25CON    (GPIO_CMGP_BASE_ADDRESS + 0x320)


#define GPIO_REG_ADDR(base, dat, pud, drv, conpdn, pudpdn) \
    (REG_GPIO_##base##CON), \
    (REG_GPIO_##base##CON + dat), \
    (REG_GPIO_##base##CON + pud), \
    (REG_GPIO_##base##CON + drv), \
    (REG_GPIO_##base##CON + conpdn), \
    (REG_GPIO_##base##CON + pudpdn)

#define GPIO_REG_NWEINT_ADDR(group, flt) \
    REG_GPIO_NWEINT_##group##_CON, \
    REG_GPIO_NWEINT_##group##_FLTCON##flt, \
    REG_GPIO_NWEINT_##group##_MASK, \
    REG_GPIO_NWEINT_##group##_PEND

static const GpioPinInfoType mGpioPinInfo[GPIO_MAX_PIN_NUM] = {
    // GPIO_CHUB ======================

    /* GPIO_H0_0  */ {0, 4, 1, 4, 4, 2, 4,
                        GPIO_REG_ADDR(GPH0, 0x4, 0x8, 0xC, 0x10, 0x14)},
    /* GPIO_H0_1  */ {1, 4, 1, 4, 4, 2, 4,
                        GPIO_REG_ADDR(GPH0, 0x4, 0x8, 0xC, 0x10, 0x14)},
    /* GPIO_H0_2  */ {2, 4, 1, 4, 4, 2, 4,
                        GPIO_REG_ADDR(GPH0, 0x4, 0x8, 0xC, 0x10, 0x14)},
    /* GPIO_H0_3  */ {3, 4, 1, 4, 4, 2, 4,
                        GPIO_REG_ADDR(GPH0, 0x4, 0x8, 0xC, 0x10, 0x14)},

    /* GPIO_H1_0  */ {0, 4, 1, 4, 4, 2, 4,
                        GPIO_REG_ADDR(GPH1, 0x4, 0x8, 0xC, 0x10, 0x14)},
    /* GPIO_H1_1  */ {1, 4, 1, 4, 4, 2, 4,
                        GPIO_REG_ADDR(GPH1, 0x4, 0x8, 0xC, 0x10, 0x14)},
    /* GPIO_H1_2  */ {2, 4, 1, 4, 4, 2, 4,
                        GPIO_REG_ADDR(GPH1, 0x4, 0x8, 0xC, 0x10, 0x14)},

    // GPIO_CMGP ======================

    /* GPIO_M00_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM00, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M01_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM01, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M02_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM02, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M03_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM03, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M04_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM04, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M05_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM05, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M06_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM06, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M07_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM07, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M08_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM08, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M09_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM09, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M10_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM10, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M11_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM11, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M12_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM12, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M13_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM13, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M14_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM14, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M15_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM15, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M16_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM16, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M17_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM17, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M18_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM18, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M19_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM19, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M20_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM20, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M21_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM21, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M22_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM22, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M23_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM23, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M24_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM24, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
    /* GPIO_M25_0  */ {0, 4, 1, 4, 4, 0, 0,
                        GPIO_REG_ADDR(GPM25, 0x4, 0x8, 0xC, 0x1C, 0x1C)},
};

#define    REG_GPIO_NWEINT_GPH0_CON        (GPIO_BASE_ADDRESS + 0x700)
#define    REG_GPIO_NWEINT_GPH1_CON        (GPIO_BASE_ADDRESS + 0x704)
#define    REG_GPIO_NWEINT_GPH0_FLTCON0    (GPIO_BASE_ADDRESS + 0x800)
#define    REG_GPIO_NWEINT_GPH1_FLTCON0    (GPIO_BASE_ADDRESS + 0x804)
#define    REG_GPIO_NWEINT_GPH0_MASK       (GPIO_BASE_ADDRESS + 0x900)
#define    REG_GPIO_NWEINT_GPH1_MASK       (GPIO_BASE_ADDRESS + 0x904)
#define    REG_GPIO_NWEINT_GPH0_PEND       (GPIO_BASE_ADDRESS + 0xA00)
#define    REG_GPIO_NWEINT_GPH1_PEND       (GPIO_BASE_ADDRESS + 0xA04)
#define    REG_GPIO_NWEINT_GPH0_FIXPRI     (GPIO_BASE_ADDRESS + 0xB14)
#define    REG_GPIO_NWEINT_GPH1_FIXPRI     (GPIO_BASE_ADDRESS + 0xB18)
#define    REG_GPIO_TZPC_SHUB              (GPIO_BASE_ADDRESS + 0x2000)


#define    REG_GPIO_NWEINT_GPM00_CON       (GPIO_CMGP_BASE_ADDRESS + 0x700)
#define    REG_GPIO_NWEINT_GPM01_CON       (GPIO_CMGP_BASE_ADDRESS + 0x704)
#define    REG_GPIO_NWEINT_GPM02_CON       (GPIO_CMGP_BASE_ADDRESS + 0x708)
#define    REG_GPIO_NWEINT_GPM03_CON       (GPIO_CMGP_BASE_ADDRESS + 0x70C)
#define    REG_GPIO_NWEINT_GPM04_CON       (GPIO_CMGP_BASE_ADDRESS + 0x710)
#define    REG_GPIO_NWEINT_GPM05_CON       (GPIO_CMGP_BASE_ADDRESS + 0x714)
#define    REG_GPIO_NWEINT_GPM06_CON       (GPIO_CMGP_BASE_ADDRESS + 0x718)
#define    REG_GPIO_NWEINT_GPM07_CON       (GPIO_CMGP_BASE_ADDRESS + 0x71C)
#define    REG_GPIO_NWEINT_GPM08_CON       (GPIO_CMGP_BASE_ADDRESS + 0x720)
#define    REG_GPIO_NWEINT_GPM09_CON       (GPIO_CMGP_BASE_ADDRESS + 0x724)
#define    REG_GPIO_NWEINT_GPM10_CON       (GPIO_CMGP_BASE_ADDRESS + 0x728)
#define    REG_GPIO_NWEINT_GPM11_CON       (GPIO_CMGP_BASE_ADDRESS + 0x72C)
#define    REG_GPIO_NWEINT_GPM12_CON       (GPIO_CMGP_BASE_ADDRESS + 0x730)
#define    REG_GPIO_NWEINT_GPM13_CON       (GPIO_CMGP_BASE_ADDRESS + 0x734)
#define    REG_GPIO_NWEINT_GPM14_CON       (GPIO_CMGP_BASE_ADDRESS + 0x738)
#define    REG_GPIO_NWEINT_GPM15_CON       (GPIO_CMGP_BASE_ADDRESS + 0x73C)
#define    REG_GPIO_NWEINT_GPM16_CON       (GPIO_CMGP_BASE_ADDRESS + 0x740)
#define    REG_GPIO_NWEINT_GPM17_CON       (GPIO_CMGP_BASE_ADDRESS + 0x744)
#define    REG_GPIO_NWEINT_GPM18_CON       (GPIO_CMGP_BASE_ADDRESS + 0x748)
#define    REG_GPIO_NWEINT_GPM19_CON       (GPIO_CMGP_BASE_ADDRESS + 0x74C)
#define    REG_GPIO_NWEINT_GPM20_CON       (GPIO_CMGP_BASE_ADDRESS + 0x750)
#define    REG_GPIO_NWEINT_GPM21_CON       (GPIO_CMGP_BASE_ADDRESS + 0x754)
#define    REG_GPIO_NWEINT_GPM22_CON       (GPIO_CMGP_BASE_ADDRESS + 0x758)
#define    REG_GPIO_NWEINT_GPM23_CON       (GPIO_CMGP_BASE_ADDRESS + 0x75C)
#define    REG_GPIO_NWEINT_GPM24_CON       (GPIO_CMGP_BASE_ADDRESS + 0x760)
#define    REG_GPIO_NWEINT_GPM25_CON       (GPIO_CMGP_BASE_ADDRESS + 0x764)


#define    REG_GPIO_NWEINT_GPM00_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x800)
#define    REG_GPIO_NWEINT_GPM01_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x804)
#define    REG_GPIO_NWEINT_GPM02_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x808)
#define    REG_GPIO_NWEINT_GPM03_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x80C)
#define    REG_GPIO_NWEINT_GPM04_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x810)
#define    REG_GPIO_NWEINT_GPM05_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x814)
#define    REG_GPIO_NWEINT_GPM06_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x818)
#define    REG_GPIO_NWEINT_GPM07_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x81C)
#define    REG_GPIO_NWEINT_GPM08_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x820)
#define    REG_GPIO_NWEINT_GPM09_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x824)
#define    REG_GPIO_NWEINT_GPM10_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x828)
#define    REG_GPIO_NWEINT_GPM11_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x82C)
#define    REG_GPIO_NWEINT_GPM12_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x830)
#define    REG_GPIO_NWEINT_GPM13_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x834)
#define    REG_GPIO_NWEINT_GPM14_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x838)
#define    REG_GPIO_NWEINT_GPM15_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x83C)
#define    REG_GPIO_NWEINT_GPM16_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x840)
#define    REG_GPIO_NWEINT_GPM17_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x844)
#define    REG_GPIO_NWEINT_GPM18_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x848)
#define    REG_GPIO_NWEINT_GPM19_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x84C)
#define    REG_GPIO_NWEINT_GPM20_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x850)
#define    REG_GPIO_NWEINT_GPM21_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x854)
#define    REG_GPIO_NWEINT_GPM22_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x858)
#define    REG_GPIO_NWEINT_GPM23_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x85C)
#define    REG_GPIO_NWEINT_GPM24_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x860)
#define    REG_GPIO_NWEINT_GPM25_FLTCON0   (GPIO_CMGP_BASE_ADDRESS + 0x864)


#define    REG_GPIO_NWEINT_GPM00_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x900)
#define    REG_GPIO_NWEINT_GPM01_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x904)
#define    REG_GPIO_NWEINT_GPM02_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x908)
#define    REG_GPIO_NWEINT_GPM03_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x90C)
#define    REG_GPIO_NWEINT_GPM04_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x910)
#define    REG_GPIO_NWEINT_GPM05_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x914)
#define    REG_GPIO_NWEINT_GPM06_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x918)
#define    REG_GPIO_NWEINT_GPM07_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x91C)
#define    REG_GPIO_NWEINT_GPM08_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x920)
#define    REG_GPIO_NWEINT_GPM09_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x924)
#define    REG_GPIO_NWEINT_GPM10_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x928)
#define    REG_GPIO_NWEINT_GPM11_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x92C)
#define    REG_GPIO_NWEINT_GPM12_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x930)
#define    REG_GPIO_NWEINT_GPM13_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x934)
#define    REG_GPIO_NWEINT_GPM14_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x938)
#define    REG_GPIO_NWEINT_GPM15_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x93C)
#define    REG_GPIO_NWEINT_GPM16_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x940)
#define    REG_GPIO_NWEINT_GPM17_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x944)
#define    REG_GPIO_NWEINT_GPM18_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x948)
#define    REG_GPIO_NWEINT_GPM19_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x94C)
#define    REG_GPIO_NWEINT_GPM20_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x950)
#define    REG_GPIO_NWEINT_GPM21_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x954)
#define    REG_GPIO_NWEINT_GPM22_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x958)
#define    REG_GPIO_NWEINT_GPM23_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x95C)
#define    REG_GPIO_NWEINT_GPM24_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x960)
#define    REG_GPIO_NWEINT_GPM25_MASK      (GPIO_CMGP_BASE_ADDRESS + 0x964)


#define    REG_GPIO_NWEINT_GPM00_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA00)
#define    REG_GPIO_NWEINT_GPM01_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA04)
#define    REG_GPIO_NWEINT_GPM02_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA08)
#define    REG_GPIO_NWEINT_GPM03_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA0C)
#define    REG_GPIO_NWEINT_GPM04_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA10)
#define    REG_GPIO_NWEINT_GPM05_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA14)
#define    REG_GPIO_NWEINT_GPM06_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA18)
#define    REG_GPIO_NWEINT_GPM07_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA1C)
#define    REG_GPIO_NWEINT_GPM08_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA20)
#define    REG_GPIO_NWEINT_GPM09_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA24)
#define    REG_GPIO_NWEINT_GPM10_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA28)
#define    REG_GPIO_NWEINT_GPM11_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA2C)
#define    REG_GPIO_NWEINT_GPM12_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA30)
#define    REG_GPIO_NWEINT_GPM13_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA34)
#define    REG_GPIO_NWEINT_GPM14_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA38)
#define    REG_GPIO_NWEINT_GPM15_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA3C)
#define    REG_GPIO_NWEINT_GPM16_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA40)
#define    REG_GPIO_NWEINT_GPM17_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA44)
#define    REG_GPIO_NWEINT_GPM18_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA48)
#define    REG_GPIO_NWEINT_GPM19_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA4C)
#define    REG_GPIO_NWEINT_GPM20_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA50)
#define    REG_GPIO_NWEINT_GPM21_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA54)
#define    REG_GPIO_NWEINT_GPM22_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA58)
#define    REG_GPIO_NWEINT_GPM23_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA5C)
#define    REG_GPIO_NWEINT_GPM24_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA60)
#define    REG_GPIO_NWEINT_GPM25_PEND      (GPIO_CMGP_BASE_ADDRESS + 0xA64)
#define    REG_GPIO_TZPC_CMGP_0            (GPIO_CMGP_BASE_ADDRESS + 0x2000)
#define    REG_GPIO_TZPC_CMGP_1            (GPIO_CMGP_BASE_ADDRESS + 0x2004)
#define    REG_GPIO_TZPC_CMGP_2            (GPIO_CMGP_BASE_ADDRESS + 0x2008)
#define    REG_GPIO_TZPC_CMGP_3            (GPIO_CMGP_BASE_ADDRESS + 0x200C)
#define    REG_GPIO_TZPC_CMGP_4            (GPIO_CMGP_BASE_ADDRESS + 0x2010)
#define    REG_GPIO_TZPC_CMGP_5            (GPIO_CMGP_BASE_ADDRESS + 0x2014)
#define    REG_GPIO_TZPC_CMGP_6            (GPIO_CMGP_BASE_ADDRESS + 0x2018)



const GpioEintInfoType mGpioEintInfo[GPIO_MAX_EINT_NUM] = {

    /* NWEINT_GPH0_EINT_0  */ { 0,  0, 0, 0, GPIO_H0_0, GPIO_REG_NWEINT_ADDR(GPH0, 0)},
    /* NWEINT_GPH0_EINT_1  */ { 4,  8, 1, 1, GPIO_H0_1, GPIO_REG_NWEINT_ADDR(GPH0, 0)},
    /* NWEINT_GPH0_EINT_2  */ { 8, 16, 2, 2, GPIO_H0_2, GPIO_REG_NWEINT_ADDR(GPH0, 0)},
    /* NWEINT_GPH0_EINT_3  */ {12, 24, 3, 3, GPIO_H0_3, GPIO_REG_NWEINT_ADDR(GPH0, 0)},

    /* NWEINT_GPH1_EINT_0  */ { 0,  0, 0, 0, GPIO_H1_0, GPIO_REG_NWEINT_ADDR(GPH1, 0)},
    /* NWEINT_GPH1_EINT_1  */ { 4,  8, 1, 1, GPIO_H1_1, GPIO_REG_NWEINT_ADDR(GPH1, 0)},
    /* NWEINT_GPH1_EINT_2  */ { 8, 16, 2, 2, GPIO_H1_2, GPIO_REG_NWEINT_ADDR(GPH1, 0)},

    /* NWEINT_GPM00_EINT_0*/ { 0,  0, 0, 0, GPIO_M00_0, GPIO_REG_NWEINT_ADDR(GPM00,0)},
    /* NWEINT_GPM01_EINT_0*/ { 0,  0, 0, 0, GPIO_M01_0, GPIO_REG_NWEINT_ADDR(GPM01,0)},
    /* NWEINT_GPM02_EINT_0*/ { 0,  0, 0, 0, GPIO_M02_0, GPIO_REG_NWEINT_ADDR(GPM02,0)},
    /* NWEINT_GPM03_EINT_0*/ { 0,  0, 0, 0, GPIO_M03_0, GPIO_REG_NWEINT_ADDR(GPM03,0)},
    /* NWEINT_GPM04_EINT_0*/ { 0,  0, 0, 0, GPIO_M04_0, GPIO_REG_NWEINT_ADDR(GPM04,0)},
    /* NWEINT_GPM05_EINT_0*/ { 0,  0, 0, 0, GPIO_M05_0, GPIO_REG_NWEINT_ADDR(GPM05,0)},
    /* NWEINT_GPM06_EINT_0*/ { 0,  0, 0, 0, GPIO_M06_0, GPIO_REG_NWEINT_ADDR(GPM06,0)},
    /* NWEINT_GPM07_EINT_0*/ { 0,  0, 0, 0, GPIO_M07_0, GPIO_REG_NWEINT_ADDR(GPM07,0)},
    /* NWEINT_GPM08_EINT_0*/ { 0,  0, 0, 0, GPIO_M08_0, GPIO_REG_NWEINT_ADDR(GPM08,0)},
    /* NWEINT_GPM09_EINT_0*/ { 0,  0, 0, 0, GPIO_M09_0, GPIO_REG_NWEINT_ADDR(GPM09,0)},
    /* NWEINT_GPM10_EINT_0*/ { 0,  0, 0, 0, GPIO_M10_0, GPIO_REG_NWEINT_ADDR(GPM10,0)},
    /* NWEINT_GPM11_EINT_0*/ { 0,  0, 0, 0, GPIO_M11_0, GPIO_REG_NWEINT_ADDR(GPM11,0)},
    /* NWEINT_GPM12_EINT_0*/ { 0,  0, 0, 0, GPIO_M12_0, GPIO_REG_NWEINT_ADDR(GPM12,0)},
    /* NWEINT_GPM13_EINT_0*/ { 0,  0, 0, 0, GPIO_M13_0, GPIO_REG_NWEINT_ADDR(GPM13,0)},
    /* NWEINT_GPM14_EINT_0*/ { 0,  0, 0, 0, GPIO_M14_0, GPIO_REG_NWEINT_ADDR(GPM14,0)},
    /* NWEINT_GPM15_EINT_0*/ { 0,  0, 0, 0, GPIO_M15_0, GPIO_REG_NWEINT_ADDR(GPM15,0)},
    /* NWEINT_GPM16_EINT_0*/ { 0,  0, 0, 0, GPIO_M16_0, GPIO_REG_NWEINT_ADDR(GPM16,0)},
    /* NWEINT_GPM17_EINT_0*/ { 0,  0, 0, 0, GPIO_M17_0, GPIO_REG_NWEINT_ADDR(GPM17,0)},
    /* NWEINT_GPM18_EINT_0*/ { 0,  0, 0, 0, GPIO_M18_0, GPIO_REG_NWEINT_ADDR(GPM18,0)},
    /* NWEINT_GPM19_EINT_0*/ { 0,  0, 0, 0, GPIO_M19_0, GPIO_REG_NWEINT_ADDR(GPM19,0)},
    /* NWEINT_GPM20_EINT_0*/ { 0,  0, 0, 0, GPIO_M20_0, GPIO_REG_NWEINT_ADDR(GPM20,0)},
    /* NWEINT_GPM21_EINT_0*/ { 0,  0, 0, 0, GPIO_M21_0, GPIO_REG_NWEINT_ADDR(GPM21,0)},
    /* NWEINT_GPM22_EINT_0*/ { 0,  0, 0, 0, GPIO_M22_0, GPIO_REG_NWEINT_ADDR(GPM22,0)},
    /* NWEINT_GPM23_EINT_0*/ { 0,  0, 0, 0, GPIO_M23_0, GPIO_REG_NWEINT_ADDR(GPM23,0)},
    /* NWEINT_GPM24_EINT_0*/ { 0,  0, 0, 0, GPIO_M24_0, GPIO_REG_NWEINT_ADDR(GPM24,0)},
    /* NWEINT_GPM25_EINT_0*/ { 0,  0, 0, 0, GPIO_M25_0, GPIO_REG_NWEINT_ADDR(GPM25,0)}
};

#endif

